"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateBatchClaimCommands = exports.validateClaimCommand = void 0;
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
const is_energy_value_1 = require("./decorators/is-energy-value");
const validator_config_1 = require("./validator.config");
const validateClaimCommand = async (command) => await class_validator_1.validateOrReject(class_transformer_1.plainToClass(ClaimCommandDto, command), validator_config_1.validatorOptions);
exports.validateClaimCommand = validateClaimCommand;
const validateBatchClaimCommands = async (commands) => {
    const validationErrors = await Promise.all(commands.map((command) => class_validator_1.validate(class_transformer_1.plainToClass(ClaimCommandDto, command))));
    if (validationErrors.every((errors) => errors.length === 0)) {
        return;
    }
    throw validationErrors;
};
exports.validateBatchClaimCommands = validateBatchClaimCommands;
class ClaimDataDto {
}
__decorate([
    class_validator_1.IsString(),
    __metadata("design:type", String)
], ClaimDataDto.prototype, "beneficiary", void 0);
__decorate([
    class_validator_1.IsString(),
    __metadata("design:type", String)
], ClaimDataDto.prototype, "location", void 0);
__decorate([
    class_validator_1.IsString(),
    __metadata("design:type", String)
], ClaimDataDto.prototype, "countryCode", void 0);
__decorate([
    class_validator_1.IsString(),
    __metadata("design:type", String)
], ClaimDataDto.prototype, "periodStartDate", void 0);
__decorate([
    class_validator_1.IsString(),
    __metadata("design:type", String)
], ClaimDataDto.prototype, "periodEndDate", void 0);
__decorate([
    class_validator_1.IsString(),
    __metadata("design:type", String)
], ClaimDataDto.prototype, "purpose", void 0);
class ClaimCommandDto {
}
__decorate([
    class_validator_1.IsNumber(),
    class_validator_1.Min(0),
    __metadata("design:type", Number)
], ClaimCommandDto.prototype, "certificateId", void 0);
__decorate([
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => ClaimDataDto),
    __metadata("design:type", ClaimDataDto)
], ClaimCommandDto.prototype, "claimData", void 0);
__decorate([
    class_validator_1.IsEthereumAddress(),
    __metadata("design:type", String)
], ClaimCommandDto.prototype, "forAddress", void 0);
__decorate([
    class_validator_1.IsOptional(),
    is_energy_value_1.IsEnergyValue(),
    __metadata("design:type", String)
], ClaimCommandDto.prototype, "energyValue", void 0);
//# sourceMappingURL=claim-command.validator.js.map